# Contributing to Kur8

Thank you for your contribution! Contributions are welcome and are greatly appreciated and every little bit helps.

## Reporting Bugs

All code changes happen through Github Pull Requests and we actively welcome them. To submit your pull request, follow the steps below:

## Pull Requests

1. Fork the repo and create your featured branch.
2. If you've added code that should be tested, add tests.
3. Ensure the test suite passes and on Travis CI as well.
4. Make sure your code lints.
5. Issue that pull request!
6. Specify what you changed in details when you are doing pull request.

Note: Any contributions you make will be under the MIT Software License and your submissions are understood to be under the same that covers the project. Please reach out to the team if you have any questions.

## Issues

We use GitHub issues to track public bugs. Please ensure your description is clear and has sufficient instructions to be able to reproduce the issue.

## Coding Style

* 2 spaces for indentation rather than tabs
* 80 character line length
* Run `npm run lint` to conform to our lint rules

## License

By contributing, you agree that your contributions will be licensed under Kur8's MIT License.

### References

This document was adapted from the open-source contribution guidelines for [Facebook's Draft](https://github.com/facebook/draft-js/blob/master/CONTRIBUTING.md)
